package com.qmth.demo.api.controller;

import com.qmth.boot.api.annotation.Aac;
import com.qmth.boot.api.annotation.BOOL;
import com.qmth.boot.api.config.ApiConfig;
import com.qmth.boot.api.constant.ApiConstant;
import com.qmth.boot.core.enums.Platform;
import com.qmth.boot.core.security.config.SecurityConfig;
import com.qmth.boot.core.uid.service.UidService;
import org.apache.commons.lang3.RandomUtils;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;

@RestController
@RequestMapping(ApiConstant.DEFAULT_URI_PREFIX)
@Aac(strict = BOOL.FALSE, auth = BOOL.FALSE)
public class IndexController {

    @Resource
    private ApiConfig apiConfig;

    @Resource
    private UidService uidService;

    @Resource
    private SecurityConfig securityConfig;

    @RequestMapping("/strict")
    @Aac(strict = BOOL.TRUE)
    public Object strict() {
        return true;
    }

    @RequestMapping("/platform")
    @Aac(platform = Platform.WEB)
    public Object platform() {
        return true;
    }

    @RequestMapping("/auth")
    @Aac(auth = BOOL.TRUE)
    public Object auth() {
        return true;
    }

    @RequestMapping("/ipAllow")
    @Aac(ipAllow = "172.16.*.*")
    public Object ipallow() {
        return true;
    }

    @RequestMapping("/config")
    public Object config() {
        return apiConfig;
    }

    @RequestMapping("/security")
    public Object security() {
        return securityConfig;
    }

    @RequestMapping("/uid")
    public Object getUid() {
        return uidService.getId();
    }

    @RequestMapping("/rateLimit")
    @Aac(rateLimit = "1/1s")
    public Object rateLimit() {
        return true;
    }

    @RequestMapping("/caller")
    public Object caller(HttpServletRequest request) {
        request.setAttribute(ApiConstant.ATTRIBUTE_CALLER, String.valueOf(RandomUtils.nextInt()));
        return true;
    }
}
